#include <avr/io.h>
#include <avr/io2313.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/eeprom.h>
//#include <avr/pgmspace.h>
#include "zng7.h"

#define  RVR  0  //PORT     //B
#define  NRV  0  //DDR
#define  TSP  1  //PIN
#define  SGF  2  //PORT
#define  NDW  2  //DDR
#define  KDW  2  //PIN
#define  SGG  3    //PORT
#define  NUP  3    //DDR
#define  KUP  3    //PIN 
#define  SGB  4  //PORT
#define  SGE  5  //PORT
#define  SGD  6  //PORT
#define  SGC  7  //PORT

#define   NG  0  //PORT    //D
#define  CUL  1  //PORT
#define   KZ  2  //PIN
#define  AN1  3  //PORT
#define  AN2  4  //PORT
#define  AN3  5  //PORT
#define  SGA  6  //PORT

#define  TOPR 9

EEMEM unsigned int PUSTO=0;
EEMEM unsigned int USTM=153;
EEMEM unsigned int  TIME=9;
EEMEM unsigned int PWM=10;


unsigned int  TEST=0;
unsigned char CTMP=0;
unsigned char CPWM=0;
unsigned int  STMP=0;
unsigned int  DTMP=0;
unsigned char TKUP=0;
unsigned char TKDW=0;
unsigned char TKUD=0;
unsigned char SIND=1;
unsigned char ALR=0;
unsigned char CNIN=0;
unsigned char CNSI=0;
const unsigned char SMZ[10]={SM_0,SM_1,SM_2,SM_3,SM_4,SM_5,SM_6,SM_7,SM_8,SM_9};//PROGMEM
unsigned char AZN[4]={0,0,0,0};
unsigned int MUSTM=0;
unsigned int MTIME=0;
unsigned int MPWM=0;//CHAR
unsigned int SEC=0;
unsigned char CPRG=0;
unsigned int VPRG=0;

unsigned char TMCL=0;

unsigned char BIT=0;
#define STCON 0
#define NPRG 1
#define STTM 2
#define CULS 3

static void conv10_2 (unsigned int a1);
static void selind(void);
static void ind7 (unsigned char SEGM);
static void conin (void);
void contmp (void);
static void progr (void);
static unsigned int varprg (unsigned int lim, unsigned int zn);
static void wreep (void);

#define DELAY_US(X) _delay_us((X))
 

//////////////////////////////////////////////////////////
SIGNAL (SIG_INTERRUPT0)
{/*uncomment @Vit*/
  if bit_is_clear (PIND,KZ)
  {
  DELAY_US(60.0);
       if bit_is_clear (PIND,KZ)  
       {
       PORTD|=(1<<NG);;
       ALR=3;
       }
  }
}
//////////////////////////////////////////////////////////

SIGNAL (SIG_OVERFLOW0)// Timer 0 overflow 
{
__asm__("wdr;");
TCNT0=162;// 6mS
CNIN++;
if (CNIN==5)CNIN=1;

if (CNIN==4)
{
conin();  //3*OV_T1=20mS
  if (MUSTM<(DTMP+15))
  {
  BIT|=(1<<STTM);//STTM=1;
  MPWM=16;
  }
  else 
  {     
    if bit_is_clear(BIT,NPRG)MPWM=eeprom_read_word(&PWM);//NPRG==0
  }
CPWM++;
  if (CPWM>MPWM&&MTIME>0&&MUSTM>DTMP&&ALR==0) PORTD&=~(1<<NG);//NG=0;
     if (CPWM>19)
     {
     CPWM=0;
     PORTD|=(unsigned char)(1<<NG);//NG=1;
     }
CNSI++;
   if (CNSI>10) //200ms
   {
   CNSI=0;
   
   selind();
   SEC++;
     if (SEC==299) //~1min
     {
     SEC=0;
       if (MTIME>0 && bit_is_set(BIT,STTM))//STTM==1
       {
       MTIME--;
         if ((MTIME&0B00000001)==0)wreep();//   EEPROM
       }
       if (MTIME==0&&DTMP>90)TMCL++;
       else TMCL=0;
           if (TMCL>5)
           {
           PORTD|=(1<<CUL);//CUL=1;   // 
           BIT|=(1<<CULS);//CULS=1;
           BIT|=(1<<STTM);//STTM=0;
           }
           else PORTD&=~(1<<CUL);//CUL=0;
          
     }
          if (CPRG>0)CPRG--;
   }
TCNT0=252;         
}
  if (CNIN==3)
  {
   PORTD|=(1<<AN2);//AN2=1;
   PORTD|=(1<<AN1);//AN1=1;
   ind7(AZN[3]);
   PORTD&=~(1<<AN3);//AN3=0;
   BIT|=(1<<STCON);//STCON=1;
  }
      if (CNIN==2)
     {
     PORTD|=(1<<AN3);//AN3=1;
     PORTD|=(1<<AN1);//AN1=1;
     ind7(AZN[2]);
     PORTD&=~(1<<AN2);//AN2=0;
     }
          if (CNIN==1)
         {
         PORTD|=(1<<AN2);//AN2=1;
         PORTD|=(1<<AN3);//AN3=1;
         ind7(AZN[1]);
         PORTD&=~(1<<AN1);//AN1=0;
         }

}
/////////////////////////////////////////////////////////////
SIGNAL (SIG_COMPARATOR)// Analog Comparator
{
#define  SMESH 1994//2026   //1978
unsigned int A;
  if bit_is_set (ACSR,5)
  {
  DELAY_US(60.0);
      if bit_is_set (ACSR,5)
      {
	  DELAY_US(60.0);
         if bit_is_set (ACSR,5)
         {
         
         A=TCNT1;     //TCNT MAX 6000 0C
         A=(A>>1);
         STMP=STMP+A;
         CTMP++;
           if (CTMP>15)
           {
           CTMP=0;
           DTMP=(STMP>>4);
             if (DTMP>SMESH)
             {
             DTMP=(DTMP-SMESH);
               if (ALR==8)ALR=0;
             }
             else DTMP=0;   
           //DTMP=DTMP*31;   //K=30/256=0.117( 0,119)
		   A = DTMP;//K=30/256=0.117( 0,119)
           DTMP=(DTMP<<5)-A;   

           DTMP=(DTMP>>8);
           ;
           
           STMP=0;
           }
         ACSR&=~(1<<3);
         TCCR1B=0;
         }
      }
  }   
}
//////////////////////////////////////////////////
static void wreep (void)
{
eeprom_write_word(&TIME,MTIME);//TIME=MTIME;

  if bit_is_clear(BIT,STTM)//    "INT T0"   TIME
  {
  eeprom_write_word(&PWM,MPWM);//PWM=MPWM;
  eeprom_write_word(&USTM,MUSTM);//USTM=MUSTM;
  }
}
//////////////////////////////////////////////////
static unsigned int varprg (unsigned int lim, unsigned int zn)
{ 
VPRG=zn;
    if (TKUP==TOPR&&VPRG<lim)
    {
    VPRG++;
    TKUP=214;
    CPRG=25; 
    }
      if(TKDW==TOPR&&VPRG>0) 
      {
      VPRG--;
      TKDW=214;
      CPRG=25;
      }

zn=VPRG;          
return zn;
}
//////////////////////////////////////////////////////////
////////////////////////////////////////////////////////
static void progr (void)
{
BIT|=(1<<NPRG);//NPRG=1;
TKUD=164;
_delay_ms(1500.0);
SIND=1;
CPRG=25; //25*0.2=5S CPRG-- IN  T0
while (CPRG>0)MTIME=varprg (99,MTIME);
SIND=2;
CPRG=25;
while (CPRG>0)MUSTM=varprg (200,MUSTM);
SIND=3;
CPRG=25;
while (CPRG>0)MPWM=varprg (18,MPWM);
BIT&=~(1<<STTM);//STTM=0;
wreep();
SIND=2;
BIT&=~(1<<NPRG);//NPRG=0;
}
//////////////////////////////////////////////////
void contmp (void)
{
       
       TCNT1=0;
       DDRB&=~(1<<NRV);//NRV=0;          // RVR IN
       
	   DELAY_US(60.0);
       TCCR1B=1;
       ACSR|=(1<<3);  // ENB INT AC
  
	   DELAY_US(6.0);
       ACSR&=~(1<<3);
        
          if (TCCR1B!=0)  //    
          {
          TCCR1B=0;       //       
          ALR=8;
          }
       DDRB|=(1<<NRV);//NRV=1;
       PORTB&=~(1<<RVR);//RVR=0;
       BIT&=~(1<<STCON);//STCON=0;
}
/////////////////////////////////////////////////////////////////
static void conin (void)  //  0   20mS
{
  PORTD|=(1<<AN1); //AN1=1;
  PORTD|=(1<<AN2); //AN2=1;
  PORTD|=(1<<AN3); //AN3=1;
  PORTB|=(1<<SGG);//SG=1;
  DDRB&=~(1<<NUP);//NUP=0;
  PORTB|=(1<<SGF);//SF=1;
  DDRB&=~(1<<NDW);//NDW=0;

 DELAY_US(90.0);
    if (bit_is_clear(PINB,KUP)&& bit_is_set(PINB,KDW))  //(KUP==0&&KDW==1)
    {
      if (TKUP!=TOPR)TKUP++;
    } 
    else  TKUP=0;
         if (bit_is_clear(PINB,KDW)&& bit_is_set(PINB,KUP))//(KDW==0&&KUP==1)
         {
           if (TKDW!=TOPR) TKDW++;
         }  
         else TKDW=0;
              if (bit_is_clear(PINB,KDW)&& bit_is_clear(PINB,KUP))//(KUP==0&&KDW==0) 
              {
                if (TKUD!=TOPR) TKUD++;
              }
              else TKUD=0;
         
DDRB|=(1<<NUP);//NUP=1;
DDRB|=(1<<NDW);//NDW=1;                 
}
/////////////////////////////////////////////////////////////////////////////
static void ind7 (unsigned char SEGM)
{
cli();
if bit_is_set (SEGM,0) PORTD|=(1<<SGA); //SGA=UBRR,0;
else PORTD&=~(1<<SGA);
if bit_is_set (SEGM,1) PORTB|=(1<<SGB); //SGB=UBRR,1;
else PORTB&=~(1<<SGB);
if bit_is_set (SEGM,2) PORTB|=(1<<SGC); //SGC=UBRR,2;
else PORTB&=~(1<<SGC);
if bit_is_set (SEGM,3) PORTB|=(1<<SGD); //SGD=UBRR,3;
else PORTB&=~(1<<SGD);
if bit_is_set (SEGM,4) PORTB|=(1<<SGE); //SGE=UBRR,4;
else PORTB&=~(1<<SGE);
if bit_is_set (SEGM,5) PORTB|=(1<<SGF); //SGF=UBRR,5;
else PORTB&=~(1<<SGF);
if bit_is_set (SEGM,6) PORTB|=(1<<SGG); //SGG=UBRR,6;
else PORTB&=~(1<<SGG);
sei();
}
//////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
static void selind(void)
{
  if (ALR==0)
  {
    if (SIND==1)//TIMER
    {
     if bit_is_clear(BIT,NPRG)conv10_2(MTIME);//NPRG==0
       else conv10_2(VPRG);
       AZN[3]=SM_H;

    }
      if (SIND==2)
      {
       if bit_is_clear(BIT,NPRG) conv10_2(DTMP);//TEMPERATURE //(NPRG==0)
       else conv10_2(VPRG);
        if(bit_is_set(BIT,STTM)&&MTIME>0) AZN[3]&=~(1<<5);//STTM==1 
      }
    if(SIND==3)
    {
    if bit_is_clear(BIT,NPRG)conv10_2(MPWM);//(NPRG==0)
    else conv10_2(VPRG);
    AZN[3]=SM_P;
    } 
      if (SIND==4)
      {
      AZN[3]=SM_P;
      AZN[2]=SM_r;
      AZN[1]=SM_G;
      } 
          if (SIND==5)
          { 
          AZN[3]=SM_E;
          AZN[2]=SM_n;
          AZN[1]=SM_d;
          } 
  }
  else
  {/*uncomment @Vit */
    if (ALR==3)      
    {                
    AZN[3]=SM_P;
    AZN[2]=SM_E;
    AZN[1]=SM_r;
    }
      if (ALR==8)
      {
      AZN[3]=SM_n;
      AZN[2]=SM_o;
      AZN[1]=SM_d;
      }     
  }  
}
/////////////////////////////////////////////////
const unsigned char arr[]={1,10,100};
static void conv10_2 (unsigned int a1)
{
unsigned char ii = 2;
unsigned char rz;

AZN[1]=0;
AZN[2]=0;
AZN[3]=0;

  while(ii)
  {
  rz=arr[ii];
    while (a1>=rz)
    {
     AZN[ii+1]++;
     a1-=rz;
    }
   --ii;
  }
  AZN[1]=a1; 

   if (AZN[3]>9) AZN[3]=AZN[3]-10;       
  //cli();       
  AZN[1]=SMZ[AZN[1]];
  AZN[2]=SMZ[AZN[2]];
  AZN[3]=SMZ[AZN[3]];       
  //sei();
}
//////////////////////////////////////////////

int main(void) __attribute__((OS_main));
int main(void)
{

PORTB=0xFC;
DDRB=0xFD;

PORTD=0x7D;
DDRD=0x7B;

TCCR0=0x04;
TCNT0=0x00;

TCCR1A=0x00;
TCCR1B=0;
TCNT1H=0x00;
TCNT1L=0x00;
OCR1H=0x00;
OCR1L=0x00;

GIMSK=0x40;
MCUCR=0x00;
GIFR=0x40;
// 

TIMSK=0x02;

ACSR=0B00000011;

WDTCR=0x0F;


MUSTM=eeprom_read_word(&USTM);//USTM;
MTIME=eeprom_read_word(&TIME);//TIME;
MPWM=eeprom_read_word(&PWM);//PWM;
sei();

 
  while (1)
  {
       if bit_is_set(BIT,STCON) contmp();//(STCON==1)contmp();
       if bit_is_clear(BIT,NPRG)SIND=varprg (3,SIND);//NPRG==0
         if (bit_is_set(BIT,CULS)&& bit_is_clear(PORTD,CUL))//CULS==1
         {
         BIT&=~(1<<CULS);//CULS=0;
         SIND=5;
         }
       if (TKUD==TOPR) 
	   {
	   SIND=4;
	   progr();
	   }  
   };
}
